Subject: bug#69480: Emacs Lisp needs, for its great 'native-compile', 'declare' and 'the' for fixnums and arrays.

From: Andrea Corallo <[email-masked]>
Date: Fri, 01 Mar 2024 09:07:54 -0500

Stephen Berman <[email-masked]> writes:

> On Fri, 01 Mar 2024 15:41:24 +0200 Eli Zaretskii <[email-masked]> wrote:
>
>>> From: Stephen Berman <[email-masked]>
>>> Cc: [email-masked],  [email-masked],  [email-masked],
>>>   [email-masked]
>>> Date: Fri, 01 Mar 2024 14:07:50 +0100
>>>
>>> On Fri, 01 Mar 2024 14:45:39 +0200 Eli Zaretskii <[email-masked]> wrote:
>>>
>>> >> It's still slower with native compilation than with byte compilation on
>>> >> my machine, unlike on yours.  Do you have any idea why?
>>> >
>>> > Maybe your system takes time to allocate memory?  This program
>>> > allocates almost 850MB of memory on my system, so maybe yours starts
>>> > paging?
>>>
>>> I see a similar allocation, but I have 16 GB of RAM (~12 of which were
>>> free when I ran the benchmark), so I think that shouldn't be an issue.
>>>
>>> > Anyway, profiling could give some hints.
>>>
>>> That says almost all memory and CPU are consumed by `build-sieve':
>>
>> This is skewed, use cpu profiling instead of "memory" profiling.
>
> Ah, ok.
>
>>> But I don't see how that bears on the difference between native and byte
>>> compilation in my timings versus yours and Andrea's.
>>
>> My suggestion was to compare profiles in the byte-compiled and
>> native-compiled cases.
>>
>> Btw, are you running both cases in the same session?  If so, don't:
>> restart Emacs and run the other case instead.
>
> Ok, I've now done that.  Here's the report for the run with native
> compilation:
>
>        12599  95% - command-execute
>        12487  95%  - funcall-interactively
>        12486  95%   - eval-expression
>        12485  95%    - #<compiled -0x5db3e1955cb81d1>
>        12485  95%     - #<compiled -0x8a5cf032951a0fe>
>        12480  95%      - eval
>        12480  95%       - progn
>        12367  94%        - benchmark-call
>        12367  94%         - #<lambda 0x8c97b8cb7bd82>
>        12367  94%            build-sieve
>          113   0%        - emacs-lisp-native-compile-and-load
>          113   0%         - emacs-lisp-native-compile
>          113   0%          - native-compile

IIUC this is profiling the native compilation itself.

BTW I'd suggest the profile is done with perf (and running batch).

Given you see on your machine similar times for native and byte compiled
the expected outcome should be tha tthe time is spent in some C routine
of our core.

Best Regards

  Andrea